
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class App_settingsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_settings = await db.app_settings.create(
            {
                id: data.id || undefined,
        
        settings_key: data.settings_key
        ||
        null
            ,
            
        settings_value: data.settings_value
        ||
        null
            ,
            
        value_type: data.value_type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return app_settings;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const app_settingsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                settings_key: item.settings_key
            ||
            null
            ,
            
                settings_value: item.settings_value
            ||
            null
            ,
            
                value_type: item.value_type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const app_settings = await db.app_settings.bulkCreate(app_settingsData, { transaction });

        // For each item created, replace relation files
        

        return app_settings;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const app_settings = await db.app_settings.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.settings_key !== undefined) updatePayload.settings_key = data.settings_key;
        
        
        if (data.settings_value !== undefined) updatePayload.settings_value = data.settings_value;
        
        
        if (data.value_type !== undefined) updatePayload.value_type = data.value_type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await app_settings.update(updatePayload, {transaction});

        
        

        
        

        

        return app_settings;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_settings = await db.app_settings.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of app_settings) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of app_settings) {
                await record.destroy({transaction});
            }
        });


        return app_settings;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const app_settings = await db.app_settings.findByPk(id, options);

        await app_settings.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await app_settings.destroy({
            transaction
        });

        return app_settings;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const app_settings = await db.app_settings.findOne(
            { where },
            { transaction },
        );

        if (!app_settings) {
            return app_settings;
        }

        const output = app_settings.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.settings_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_settings',
                        'settings_key',
                        filter.settings_key,
                    ),
                };
            }
            
            if (filter.settings_value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_settings',
                        'settings_value',
                        filter.settings_value,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_settings',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.value_type) {
                where = {
                    ...where,
                value_type: filter.value_type,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.app_settings.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'app_settings',
                        'settings_key',
                        query,
                    ),
                ],
            };
        }

        const records = await db.app_settings.findAll({
            attributes: [ 'id', 'settings_key' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['settings_key', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.settings_key,
        }));
    }

    
};

